unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PobieranieUchwytuOkna;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
const MAX_COUNT=256;
var
  ProcessId :Cardinal;
  uchwytOkna :THandle;
  nazwaOkna :array[0..MAX_COUNT-1] of Char;
  nazwaKlasy :array[0..MAX_COUNT-1] of Char;
begin
  ProcessId:=0;
  try
    ProcessId:=StrToInt(Edit1.Text);
  except
    ShowMessage('Identyfikator procesu musi być liczbą');
    Exit;
  end;

  uchwytOkna:=GetMainWindowHandle(ProcessId);
  if uchwytOkna<>0 then
    begin
    GetWindowText(uchwytOkna,nazwaOkna,MAX_COUNT);
    GetClassName(uchwytOkna,nazwaKlasy,MAX_COUNT);
    ShowMessage('Uchwyt okna: '+IntToStr(uchwytOkna)+Chr(13)+'Nazwa okna: '+nazwaOkna+Chr(13)+'Klasa okna: '+nazwaKlasy);
    end
    else
    ShowMessage('Proces o podanym numerze PID nie istnieje');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ProcessId :Cardinal;
  uchwytOkna :THandle;
begin
  uchwytOkna:=0;
  try
    uchwytOkna:=StrToInt(Edit2.Text);
  except
    ShowMessage('Uchwyt okna musi być liczbą');
    Exit;
  end;

  if GetWindowThreadProcessId(uchwytOkna,ProcessId)<>0 then
    ShowMessage('Identyfikator procesu: '+IntToStr(ProcessId)+Chr(13)+'Uchwyt okna (test): '+IntToStr(GetMainWindowHandle(ProcessId)))
    else
    ShowMessage('Podanemu uchwytowi nie odpowiada żadne okno');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Edit1.Text:=IntToStr(GetCurrentProcessId);
Edit2.Text:=IntToStr(Form1.Handle);
end;

end.
